﻿function sendSMS(to, msg, hLog, ownerData, config)
{
	local sign = pcs(config, "sign");
	local pos = to.find("+48");
	
	if(pos == 0)
	{
		to = to.slice(3);
	}

	log(hLog, "Adresat: " + to);
	log(hLog, "Łączenie z bramką...");

	local tokenID = "l8c3gHTPoSteOR4U";
	local tokenValue = getToken("https://www1.plus.pl/bsm/jcaptcha?captchaId=" + tokenID);

	if(tokenValue == null)
	{
		log(hLog, "Błąd, brak tokenu");
		return 2;
	}

	local function replace(str, find, repl)
	{
		local ret = "";
		while(true)
		{
			local found = str.find(find);
			if(found == null) break;
			ret += str.slice(0, found) + repl;
			str = str.slice(found + find.len());
		}
		ret += str;
		return ret;
	}

	local function escapeJSON(str)
	{
		str = replace(str, "\\", "\\\\");
		str = replace(str, "\"", "\\\"");
		str = replace(str, "\f", "\\f");
		str = replace(str, "\n", "\\n");
		str = replace(str, "\r", "\\r");
		str = replace(str, "\t", "\\t");
		return str;
	}

	local postData = "{" +
		"\"receivers\":\"" + escapeJSON(to) + "\"," +
		"\"sender\":\"" + escapeJSON(sign) + "\"," +
		"\"content\":\"" + escapeJSON(msg) + "\"," +
		"\"captchaId\":\"" + escapeJSON(tokenID) + "\"," +
		"\"captchaAnswer\":\"" + escapeJSON(tokenValue) + "\"," +
		"\"captchaIdSMedia\":null," +
		"\"captchaAnswerSMedia\":\"\"," +
		"\"freeGate\":true," +
		"\"answerMessage\":false," +
		"\"saveInOutbox\":false," +
		"\"flashMessage\":false," +
		"\"sendLater\":false," +
		"\"sendDate\":null," +
		"\"draftMessageId\":null," +
		"\"draft\":false," +
		"\"mms\":false," +
		"\"type\":\"S\"," +
		"\"vCard\":false," +
		"\"idFolder\":2," +
		"\"smediaValid\":false" +
	"}";

	local hNet = httpCreate();
	local retVal = 0;

	if(hNet != null && httpOpen(hNet))
	{
		local headers = format("Content-Type: application/json;charset=utf-8\r\nAccept: application/json, text/plain, */*\r\nContent-Length: %d\r\n", postData.len());

		if(httpSetHeaders(hNet, headers))
		{
			if(httpGetFile(hNet, "https://www1.plus.pl/bsm/service/SendSmsService/send", "POST", postData, true))
			{
				local data = httpGetFileData(hNet);
				retVal = 2;

				if(data.find("\"statusCode\" : 200") != null)
				{
					log(hLog, "Wiadomość wysłana");
					retVal = 1;
				}
				else if(data.find("IncorrectCaptchaTextException") != null)
				{
					log(hLog, "Błędny token");
				}
				else if(data.find("MaxSmsFromOneIPException") != null)
				{
					log(hLog, "Przekroczono dozwoloną liczbę wysłanych SMS-ów");
				}
				else if(data.find("MaxSmsOneContentException") != null)
				{
					log(hLog, "Przekroczono dozwoloną liczbę wysłanych SMS-ów o takiej samej treści");
				}
				else if(data.find("MaxSmsToOneReceiverException") != null)
				{
					log(hLog, "Przekroczono dozwoloną liczbę wysłanych SMS-ów do tego samego odbiorcy");
				}
				else if(data.find("ForbiddenSmsContentException") != null)
				{
					log(hLog, "Treść SMS-a zawiera niedozwolone słowa");
				}
				else if(data.find("InvalidReceiverException") != null)
				{
					log(hLog, "Błędny odbiorca");
				}
				else if(data.find("Exception") != null)
				{
					log(hLog, "Nieznany błąd bramki");
				}
			}
			else
			{
				log(hLog, "Błąd połączenia");
			}
		}
		else
		{
			log(hLog, "Wewnętrzny błąd");
		}

		httpClose(hNet);
		httpDestroy(hNet);
	}
	else
	{
		log(hLog, "Wewnętrzny błąd");
	}

	return retVal;
}
